package com.dayou.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dayou.dto.AssetsStatisticalSelectDTO;
import com.dayou.vo.AssetsEvaluateDepEfficiencyVO;
import com.dayou.vo.AssetsLedgerVO;
import com.dayou.vo.AssetsPerformanceDeductionDetailVO;
import com.dayou.vo.AssetsPerformanceDeductionVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface AssetsStatisticalStatementMapper {

    /**
     * 获取资产台账
     * @param dto 查询dto
     * @return Page<AssetsLedgerVO>
     */
    Page<AssetsLedgerVO> getAssetsLedgerVO(@Param("page") Page page, @Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 获取资产台账
     * @param dto 查询dto
     * @return List<AssetsLedgerVO>
     */
    List<AssetsLedgerVO> assetsLedgerVOExport(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 评估部绩效扣分查询
     * @param dto 查询dto
     * @return List<AssetsPerformanceDeductionVO>
     */
    List<AssetsPerformanceDeductionVO> getAssetsPerformanceDeductionVO(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 评估部绩效扣分导出
     * @param dto 查询dto
     * @return Page<AssetsPerformanceDeductionVO>
     */
    List<AssetsPerformanceDeductionVO> assetsPerformanceDeductionVOExport(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 查询错误详情列表
     * @param page 分页
     * @param dto 查询dto
     * @return Page<AssetsPerformanceDeductionDetailVO>
     */
    Page<AssetsPerformanceDeductionDetailVO> getAssetsPerformanceDeductionDetail(@Param("page") Page page, @Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 错误详情列表导出
     * @param dto 查询dto
     * @return Page<AssetsPerformanceDeductionDetailVO>
     */
    List<AssetsPerformanceDeductionDetailVO> assetsPerformanceDeductionDetailExport(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 评估人员绩效扣分查询
     * @param dto 查询dto
     * @return List<AssetsPerformanceDeductionVO>
     */
    List<AssetsPerformanceDeductionVO> getAssetsPerformanceDeductionVOByEvaluator(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 评估人员绩效扣分导出
     * @param dto 查询dto
     * @return List<AssetsPerformanceDeductionVO>
     */
    List<AssetsPerformanceDeductionVO> assetsPerformanceDeductionVOByEvaluatorExport(@Param("dto") AssetsStatisticalSelectDTO dto);

    /**
     * 评估部效率查询
     * @param dto 查询dto
     * @return List<AssetsEvaluateDepEfficiencyVO>
     */
    List<AssetsEvaluateDepEfficiencyVO> getAssetsEvaluateDepEfficiencyVO(@Param("dto") AssetsStatisticalSelectDTO dto);
}
